package com.link.core.objlocalhandle.kafka;

import com.lmax.disruptor.EventHandler;
import com.lmax.disruptor.RingBuffer;
import com.lmax.disruptor.dsl.Disruptor;
import java.util.concurrent.Executor;
import java.util.concurrent.Executors;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ObjLocalKafkaUtils {
   private static Logger logger = LoggerFactory.getLogger(ObjLocalKafkaUtils.class);
   private static int INIT_SIZE = 2048;
   private static Disruptor<KafkaEvent> disruptor;

   private static Disruptor<KafkaEvent> getInstance() {
      if (null == disruptor) {
         Class var0 = ObjLocalKafkaUtils.class;
         synchronized(ObjLocalKafkaUtils.class) {
            if (null == disruptor) {
               KafkaEventFactory kafkaEventFactory = new KafkaEventFactory();
               Executor executor = Executors.newCachedThreadPool();
               disruptor = new Disruptor(kafkaEventFactory, INIT_SIZE, executor);
               disruptor.handleEventsWith(new EventHandler[]{new KafkaEventHandler()});
               disruptor.start();
            }
         }
      }

      return disruptor;
   }

   public static void publish(KafkaEvent kafkaEvent) {
      logger.info("向消息队列扔消息");
      RingBuffer<KafkaEvent> ringBuffer = disruptor.getRingBuffer();
      KafkaEventProducer producer = new KafkaEventProducer(ringBuffer);
      producer.onData(kafkaEvent);
   }

   static {
      KafkaEventFactory kafkaEventFactory = new KafkaEventFactory();
      Executor executor = Executors.newCachedThreadPool();
      disruptor = new Disruptor(kafkaEventFactory, INIT_SIZE, executor);
      disruptor.handleEventsWith(new EventHandler[]{new KafkaEventHandler()});
      disruptor.start();
   }
}
